﻿
Imports System.ComponentModel

Public Class Form1
    Public cZeichen As Char = CChar("X")
    Dim intZugzaehler As Integer = 0
    Dim intSekunden As Integer

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        LblX.Text = CStr(My.Settings.Xgewinne)
        LblO.Text = CStr(My.Settings.Ogewinne)
        LblU.Text = CStr(My.Settings.Unentschieden)
    End Sub
    Private Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        My.Settings.Xgewinne = CInt(LblX.Text)
        My.Settings.Ogewinne = CInt(LblO.Text)
        My.Settings.Unentschieden = CInt(LblU.Text)
        My.Settings.Save()
    End Sub

    Private Sub Button_Click(sender As Object, e As EventArgs) Handles btn9.Click, btn8.Click, btn7.Click, btn6.Click, btn5.Click, btn4.Click, btn3.Click, btn2.Click, btn1.Click
        Dim bt As Button = DirectCast(sender, Button)
        If bt.Text <> "" Then Exit Sub
        bt.Text = cZeichen
        If cZeichen = "X" Then
            bt.ForeColor = Color.Red
        Else
            bt.ForeColor = Color.DarkGreen
        End If

        intZugzaehler = intZugzaehler + 1
        Gewinnersuchen()

        If cZeichen = "X" Then
            cZeichen = CChar("O")
        Else
            cZeichen = CChar("X")
        End If

    End Sub

    Private Sub Gewinnersuchen()
        'horizontal
        If btn1.Text <> "" And btn1.Text = btn2.Text And btn2.Text = btn3.Text Then
            Ende(btn1, btn2, btn3)
        ElseIf btn4.Text <> "" And btn4.Text = btn5.Text And btn5.Text = btn6.Text Then
            Ende(btn4, btn5, btn6)
        ElseIf btn7.Text <> "" And btn7.Text = btn8.Text And btn8.Text = btn9.Text Then
            Ende(btn7, btn8, btn9)
            'vertikal
        ElseIf btn1.Text <> "" And btn1.Text = btn4.Text And btn4.Text = btn7.Text Then
            Ende(btn1, btn4, btn7)
        ElseIf btn2.Text <> "" And btn2.Text = btn5.Text And btn5.Text = btn8.Text Then
            Ende(btn2, btn5, btn8)
        ElseIf btn3.Text <> "" And btn3.Text = btn6.Text And btn6.Text = btn9.Text Then
            Ende(btn3, btn6, btn9)
            'diagonal
        ElseIf btn1.Text <> "" And btn1.Text = btn5.Text And btn5.Text = btn9.Text Then
            Ende(btn1, btn5, btn9)
        ElseIf btn3.Text <> "" And btn3.Text = btn5.Text And btn5.Text = btn7.Text Then
            Ende(btn3, btn5, btn7)
        ElseIf intZugzaehler = 9 Then
            Unentschieden()
        End If
    End Sub

    Private Sub Unentschieden()
        For Each Button In Me.PnlSpielfeld.Controls.OfType(Of Button)
            Button.Enabled = False
        Next
        LblU.Text = CStr(CInt(LblU.Text) + 1)
        intZugzaehler = 0
        cZeichen = CChar("=")
        Timer1.Start()
        With Form2
            .LblGewinner1.Text = "="
            .LblGewinner1.ForeColor = Color.Black
            .LblGewinner2.Text = "unentschieden"
            .Show()
        End With
    End Sub
    Private Sub Ende(Button1 As Button, Button2 As Button, Button3 As Button)
        Dim Button As Button
        If cZeichen = "X" Then
            With Button1
                .BackColor = Color.Red
                .ForeColor = Color.Black
            End With
            With Button2
                .BackColor = Color.Red
                .ForeColor = Color.Black
            End With
            With Button3
                .BackColor = Color.Red
                .ForeColor = Color.Black
            End With
            LblX.Text = CStr(CInt(LblX.Text) + 1)
            With Form2
                .LblGewinner1.Text = "X"
                .LblGewinner1.ForeColor = Color.Red
                .LblGewinner2.Text = "gewinnt"
            End With
        Else
            With Button1
                .BackColor = Color.DarkGreen
                .ForeColor = Color.Black
            End With
            With Button2
                .BackColor = Color.DarkGreen
                .ForeColor = Color.Black
            End With
            With Button3
                .BackColor = Color.DarkGreen
                .ForeColor = Color.Black
            End With
            LblO.Text = CStr(CInt(LblO.Text) + 1)
            With Form2
                .LblGewinner1.Text = "O"
                .LblGewinner1.ForeColor = Color.DarkGreen
                .LblGewinner2.Text = "gewinnt"
            End With
        End If
        For Each Button In Me.PnlSpielfeld.Controls.OfType(Of Button)
            Button.Enabled = False
        Next
        intZugzaehler = 0
        Timer1.Start()
        Form2.Show()

    End Sub

    Private Sub btnNeuesSpiel_Click(sender As Object, e As EventArgs) Handles btnNeuesSpiel.Click
        Neustarten()
    End Sub

    Private Sub Neustarten()
        Dim Button As Button
        For Each Button In Me.PnlSpielfeld.Controls.OfType(Of Button)
            With Button
                .Enabled = True
                .Text = ""
                .BackColor = Color.Gainsboro
                .FlatAppearance.BorderColor = Color.Black
            End With
        Next
        cZeichen = CChar("X")
        LblNeustart.Text = ""
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Dim i As Integer = 3
        intSekunden = intSekunden + 1
        i = i - intSekunden
        LblNeustart.Text = "Neustart in " & i & " Sekunden"
        If intSekunden = 3 Then
            Timer1.Stop()
            intSekunden = 0
            Neustarten()
        End If
    End Sub

    Private Sub btnloeschen_Click(sender As Object, e As EventArgs) Handles btnloeschen.Click
        LblX.Text = "0"
        LblO.Text = "0"
        LblU.Text = "0"
        My.Settings.Xgewinne = 0
        My.Settings.Ogewinne = 0
        My.Settings.Unentschieden = 0
        My.Settings.Save()

    End Sub
End Class
